org.codehaus.plexus.util.xml

## Class Xpp3DomUtils

- java.lang.Object
- - org.codehaus.plexus.util.xml.Xpp3DomUtils

    public class Xpp3DomUtils
    extends java.lang.Object

Author:
  Jason van Zyl

### Field Summary

Fields
`static java.lang.String` `CHILDREN_COMBINATION_APPEND`
`static java.lang.String` `CHILDREN_COMBINATION_MERGE`
`static java.lang.String` `CHILDREN_COMBINATION_MODE_ATTRIBUTE`
`static java.lang.String` `DEFAULT_CHILDREN_COMBINATION_MODE` This default mode for combining children DOMs during merge means that where element names match, the process will try to merge the element data, rather than putting the dominant and recessive elements (which share the same element name) as siblings in the resulting DOM.
`static java.lang.String` `DEFAULT_SELF_COMBINATION_MODE` This default mode for combining a DOM node during merge means that where element names match, the process will try to merge the element attributes and values, rather than overriding the recessive element completely with the dominant one.
`static java.lang.String` `SELF_COMBINATION_MERGE`
`static java.lang.String` `SELF_COMBINATION_MODE_ATTRIBUTE`
`static java.lang.String` `SELF_COMBINATION_OVERRIDE`

### Constructor Summary

Constructors
Constructor and Description
`Xpp3DomUtils()`

### Method Summary

Methods
`static boolean` `isEmpty(java.lang.String str)`
`static boolean` `isNotEmpty(java.lang.String str)`
`static Xpp3Dom` `mergeXpp3Dom(Xpp3Dom dominant, Xpp3Dom recessive)` Merge two DOMs, with one having dominance in the case of collision.
`static Xpp3Dom` `mergeXpp3Dom(Xpp3Dom dominant, Xpp3Dom recessive, java.lang.Boolean childMergeOverride)` Merge two DOMs, with one having dominance in the case of collision.
`void` `writeToSerializer(java.lang.String namespace, XmlSerializer serializer, Xpp3Dom dom)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### CHILDREN_COMBINATION_MODE_ATTRIBUTE

    public static final java.lang.String CHILDREN_COMBINATION_MODE_ATTRIBUTE

See Also:
  Constant Field Values

#### CHILDREN_COMBINATION_MERGE

    public static final java.lang.String CHILDREN_COMBINATION_MERGE

See Also:
  Constant Field Values

#### CHILDREN_COMBINATION_APPEND

    public static final java.lang.String CHILDREN_COMBINATION_APPEND

See Also:
  Constant Field Values

#### DEFAULT_CHILDREN_COMBINATION_MODE

    public static final java.lang.String DEFAULT_CHILDREN_COMBINATION_MODE

This default mode for combining children DOMs during merge means that where element names match, the process will try to merge the element data, rather than putting the dominant and recessive elements (which share the same element name) as siblings in the resulting DOM.

See Also:
  Constant Field Values

#### SELF_COMBINATION_MODE_ATTRIBUTE

    public static final java.lang.String SELF_COMBINATION_MODE_ATTRIBUTE

See Also:
  Constant Field Values

#### SELF_COMBINATION_OVERRIDE

    public static final java.lang.String SELF_COMBINATION_OVERRIDE

See Also:
  Constant Field Values

#### SELF_COMBINATION_MERGE

    public static final java.lang.String SELF_COMBINATION_MERGE

See Also:
  Constant Field Values

#### DEFAULT_SELF_COMBINATION_MODE

    public static final java.lang.String DEFAULT_SELF_COMBINATION_MODE

This default mode for combining a DOM node during merge means that where element names match, the process will try to merge the element attributes and values, rather than overriding the recessive element completely with the dominant one. This means that wherever the dominant element doesn't provide the value or a particular attribute, that value or attribute will be set from the recessive DOM node.

See Also:
  Constant Field Values

### Constructor Detail

#### Xpp3DomUtils

    public Xpp3DomUtils()

### Method Detail

#### writeToSerializer

    public void writeToSerializer(java.lang.String namespace,
                         XmlSerializer serializer,
                         Xpp3Dom dom)
                           throws java.io.IOException

Throws:
  `java.io.IOException`

#### mergeXpp3Dom

    public static Xpp3Dom mergeXpp3Dom(Xpp3Dom dominant,
                       Xpp3Dom recessive,
                       java.lang.Boolean childMergeOverride)

Merge two DOMs, with one having dominance in the case of collision.

Parameters:
  `dominant` - The dominant DOM into which the recessive value/attributes/children will be merged
  `recessive` - The recessive DOM, which will be merged into the dominant DOM
  `childMergeOverride` - Overrides attribute flags to force merging or appending of child elements into the dominant DOM
See Also:
  `CHILDREN_COMBINATION_MODE_ATTRIBUTE`, `SELF_COMBINATION_MODE_ATTRIBUTE`

#### mergeXpp3Dom

    public static Xpp3Dom mergeXpp3Dom(Xpp3Dom dominant,
                       Xpp3Dom recessive)

Merge two DOMs, with one having dominance in the case of collision. Merge mechanisms (vs. override for nodes, or vs. append for children) is determined by attributes of the dominant root node.

Parameters:
  `dominant` - The dominant DOM into which the recessive value/attributes/children will be merged
  `recessive` - The recessive DOM, which will be merged into the dominant DOM
See Also:
  `CHILDREN_COMBINATION_MODE_ATTRIBUTE`, `SELF_COMBINATION_MODE_ATTRIBUTE`

#### isNotEmpty

    public static boolean isNotEmpty(java.lang.String str)

#### isEmpty

    public static boolean isEmpty(java.lang.String str)